<?php
/*
Plugin Name: Minimum Plugin
Plugin URI: http://wpd.edilweb.eu
Description: This is an example plugin for beginners. It is very small, it displays a countdown.
Version: 2.0.0
Author: Alessandro Lin
Author URI: http://wpd.edilweb.eu
License: GPL-2
License URI: http://www.gnu.org/licenses/gpl-2.0.txt
Text Domain: MinimumPlugin
Domain Path: /languages
*/

/**
 * Copyright 2020 Alessandro Lin
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

if ( ! defined( 'ABSPATH' ) ) {	exit; }

function activate_MinimumPlugin() {}

function deactivate_MinimumPlugin(){}

function textDomain_MinimumPlugin() {
    global $pP;
    load_plugin_textdomain( $pP->plugin_name );
}

function register_setting_MinimumPlugin() {
    global $pP;
    register_setting( $pP->plugin_name, $pP->plugin_name, 'validate_settings_MinimumPlugin' );
}

function add_options_page_MinimumPlugin(){
    global $pP;
    $page_title = $pP->plugin_name;
    $menu_title = $pP->plugin_name;
    $capability = 'manage_options';
    $menu_slug = plugin_basename(__FILE__); 
    if( $pP->cheForm === 'simple' ){
        $function = 'display_setup_MinimumPlugin';
    }
    elseif ( $pP->cheForm === 'complex' ) {
         $function = 'display_setup2_MinimumPlugin';
    }    
   add_options_page( $page_title, $menu_title, $capability, $menu_slug, $function );
}


function display_setup_MinimumPlugin() {
    global $pP;
    $url = admin_url( 'options.php' );
    $db_options = get_option($pP->plugin_name);
    
    $toBw = <<<EOF
   <div class="wrap">    
    <h1>{$pP->plugin_name} Settings</h1>
    <form action="{$url}" method="post" id="MinimumPlugin-form">
EOF;
    echo $toBw;
    
    settings_fields( $pP->plugin_name );
    
    $toBw2 = <<<BW2
        <table class="form-table">
            <tbody>
                <tr>
                    <th scope="row">
                        <label for="mp_Data">Countdown departure date </label>
                    </th>
                    <td>
                        <input type="date" name="{$pP->plugin_name}" id="mp_Data"  title="countdown start" value="{$db_options}" required>
                    </td>
                </tr>
            </tbody>
        </table>
BW2;
    echo $toBw2;
    
    submit_button();

    $toBw3 = <<<BW3
    </form>
</div>
BW3;
    echo $toBw3;
}

function display_setup2_MinimumPlugin(){
    global $pP;
    $url = admin_url( 'options.php' );
    $db_options = get_option( $pP->plugin_name );
    
    /*  translations  (not performed)  */
    $cEvent = __( 'Countdown event', 'MinimumPlugin' );
    $cDate = __( 'Countdown departure date', 'MinimumPlugin' );
    $cDini = __( 'Countdown start', 'MinimumPlugin' );
    $cTime = __( 'Countdown start time', 'MinimumPlugin' );
    $cTini = __( 'Time start', 'MinimumPlugin' );
    
    $toBw = <<<EOF
<div class="wrap">    
    <h1>Minimum Plugin Settings</h1>
    <form action="{$url}" method="post" id="MinimumPlugin-form">
EOF;
    echo $toBw;
    
    settings_fields( $pP->plugin_name );
    
    $toBw2 = <<<BW2
        <table class="form-table">
            <tbody>
                <tr>
                    <th scope="row">
                        <label>ShortCode </label>
                    </th>
                    <td>
                        [MinimumPlugin]
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="mp_txt">Your Event </label>
                    </th>
                    <td>
                        <input type="text" name="{$pP->plugin_name}[mpTxt]" id="mp_txt" title="{$cEvent}" value="{$db_options['mpTxt']}" required>
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="mp_Data">{$cDate} </label>
                    </th>
                    <td>
                        <input type="date" name="{$pP->plugin_name}[mpData]" id="mp_Data"  title="{$cDini}" value="{$db_options['mpData']}" required>
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="mp_Time">{$cTime} </label>
                    </th>
                    <td>
                        <input type="time" name="{$pP->plugin_name}[mpTime]" id="mp_Time"  title="{$cTini}" value="{$db_options['mpTime']}" required>
                    </td>
                </tr>
            </tbody>
        </table>
BW2;
    echo $toBw2;
    
    submit_button();

    $toBw3 = <<<BW3
    </form>
</div>
BW3;
    echo $toBw3;
 
/* HTML for Ajax call background page */ 
/* JavaScript for Ajax call background page */    
    $toBw4 = <<<BW4
<div class="wrap">
   <hr>
   <h2>Test Ajax Backend</h2>
   <input type="text" name="mpAjax_BKT" id="mp_AjaxBKT" title="Background Ajax Test" placeholder="Input something">
   <button id="mpAjax_BKcall" class="button button-primary">Press me for Test</button>
   <p id="mpAjax_BKR"></p>
</div>
<script>document.querySelector("#mpAjax_BKR").innerHTML  = '';</script>
<script>
jQuery(document).ready(function(){            
    jQuery('#mpAjax_BKcall').click(function(){
        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                'action':'mp_ajaxBK', 
                'mp_AjaxBKT': mp_AjaxBKT.value
            },
            success: function(response){ mpAjax_BKR.innerHTML = response;},
            error: function(){ alert('ajax error. See the Console Log!'); }
        });
   });            
});
</script>    
BW4;
    echo $toBw4;
}


function validate_settings_MinimumPlugin( $input ){
    /*  here the code to validate form     */    
    global $pP; 
    
    if( $pP->cheForm === 'simple' ){                        /*  single option  1 field */
        $valid = sanitize_text_field( $input );
    }
    elseif ( $pP->cheForm === 'complex' ) {                 /*  3 fields    */
        $valid = [];
        $valid[ 'mpTxt' ] = sanitize_text_field( $input[ 'mpTxt' ]);
        $valid[ 'mpData' ] = sanitize_text_field( $input[ 'mpData' ]);
        $valid[ 'mpTime' ] = sanitize_text_field( $input[ 'mpTime' ]);
    }
    else { wp_die( __( 'administrative form error' )); }
    
    return $valid;
}

function add_filter_link_MinimumPlugin( $links ) {
    $mylinks = array( '<a href="' . admin_url( 'options-general.php?page=' . plugin_basename(__FILE__) ) . '">Settings</a>' );
    return array_merge( $links, $mylinks );
}


function shortcodes_MinimumPlugin_init(){
    global $pP;
    add_shortcode($pP->shortcode, 'shortcodes_MinimumPlugin_exec');
}


function shortcodes_MinimumPlugin_exec(){
    global $pP;
    $db_options = get_option( $pP->plugin_name );
    
    switch ($pP->cheForm) {
        case 'complex':         /* Here $db_options is an array */ /* Test ajax for non logged users */
$a1 = <<<EOF
<h3>Minimum Plugin Example</h3>
<p style="font-size: 16px; margin-bottom: 0;">{$db_options['mpTxt']}<br>{$db_options['mpData']}  &nbsp;time {$db_options['mpTime']}<br><br>Waiting Time:</p>
<p style="font-size: 22px; margin-top: 0px;" id="idMinPlug"></p>
<script>
var dateFromDb = '{$db_options['mpData']}', timeFromDb = '{$db_options['mpTime']}';var countDownDate = new Date( dateFromDb + ' ' + timeFromDb ).getTime();
var xMinimumPlugin = setInterval(function () {var now = new Date().getTime();var distance = countDownDate - now;if (distance > 0) {var days = Math.floor(distance / (1000 * 60 * 60 * 24));var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));var seconds = Math.floor((distance % (1000 * 60)) / 1000);idMinPlug.innerHTML = days + "d - " + hours + "h - " + minutes + "m : " + seconds + "s ";} else {clearInterval(xMinimumPlugin);idMinPlug.innerHTML = "EXPIRED";}}, 1000);
</script>
EOF;

        $nonce = wp_create_nonce( 'MinimumPlugin' );            /*   Create nonce */
        $ajaxURL = admin_url( 'admin-ajax.php', 'relative' );   /* get the ajax input address in wp */ 


$a2 = <<<EOF
<h4>Test Ajax FrontEnd</h4>
<input type="text" name="mpAjax_FT" id="mp_AjaxFT" title="FrontEnd Ajax Test" placeholder="Input something">
<button id="mpAjax_Fcall" class="button button-primary">Press me for Test</button>
<div id="mpLoader" class="mploader_inactive"></div>
<p id="mpAjax_FR"></p>

<script>
var mpF_nonce = '{$nonce}';
var mpF_axUrl = '{$ajaxURL}';

document.getElementById('mpAjax_Fcall').addEventListener("click", function(){
    Spin();

    function AjaxVar(){var xhr; if(window.ActiveXObject) {xhr = new ActiveXObject;} else {xhr = new XMLHttpRequest;} return xhr;}
    
    var fd = new FormData();
    fd.append( 'action', 'mp_ajaxF' );
    fd.append( 'ajax_nonce', mpF_nonce );
    fd.append( 'mp_AjaxFT', mp_AjaxFT.value );
    
    var xhr = AjaxVar();
    
    xhr.addEventListener("load", Complete);
    xhr.addEventListener("error", Err);
    xhr.addEventListener("abort", Abor);
    
    xhr.open('POST', mpF_axUrl);
    xhr.send(fd);    
    
    function Complete(){ document.getElementById('mpAjax_FR').innerHTML = xhr.responseText; Spin();}
    
    function Err(){ document.getElementById('mpAjax_FR').innerHTML = document.getElementById('mpAjax_FR').innerHTML + '<br>ajax Error ... ' + xhr.status + ' ' + xhr.statusText; Spin(); }
    
    function Abor(){ document.getElementById('mpAjax_FR').innerHTML = document.getElementById('mpAjax_FR').innerHTML + '<br>ajax Abort ... ' + xhr.status + ' ' + xhr.statusText; Spin(); }

    function Spin(){
        mpLoader.classList.toggle('mpLoader');
        mpLoader.classList.toggle('mploader_inactive');
    }
});
</script>
EOF;

            $a = $a1 . $a2;
            break;
        
        case 'simple':          /*  Here $db_options is a simple variable   */
$a = <<<EOF
<p style="font-size: 20px; margin-bottom: 0;">Countdown start: <br>day {$db_options}  &nbsp;<br><span style="font-size: 13px;">Time to end:</span></p>
<p style="height: 50px; font-size: 30px; margin-top: 0px;" id="idMinPlug"></p>
<script>
var dateFromDb = '{$db_options}', timeFromDb = '00:00';var countDownDate = new Date( dateFromDb + ' ' + timeFromDb ).getTime();
var xMinimumPlugin = setInterval(function () {var now = new Date().getTime();var distance = countDownDate - now;if (distance > 0) {var days = Math.floor(distance / (1000 * 60 * 60 * 24));var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));var seconds = Math.floor((distance % (1000 * 60)) / 1000);idMinPlug.innerHTML = days + "d - " + hours + "h - " + minutes + "m : " + seconds + "s ";} else {clearInterval(xMinimumPlugin);idMinPlug.innerHTML = "EXPIRED";}}, 1000);
</script>
EOF;
            break;

        default:
            $a = __( 'error shortcodes_MinimumPlugin_exec' );
            wp_die($a);
            break;
    }
    
    return $a;
}

/* ajax function administration page */
function mp_AjaxBKG(){
    ( $ajaxInputBKG = sanitize_text_field($_POST[ 'mp_AjaxBKT' ])) OR ( wp_die( 'No input or No valid input.' ) );
    echo $ajaxInputBKG;
    exit();
}

/*  ajax function frontend page */
function mp_AjaxFD() {
    $nonce = sanitize_text_field( $_POST[ 'ajax_nonce' ]); 
    if( !wp_verify_nonce( $nonce, 'MinimumPlugin' )){
        wp_die( '403 forbidden', 403 );
    }
    
    ( $ajaxInputF = sanitize_text_field($_POST[ 'mp_AjaxFT' ])) OR ( wp_die( 'No input or No valid input.' ));
    
    echo $ajaxInputF;
    exit();
}

/* css spin style */
function mp_spinStyle(){
    $a = <<<EOF
<style type="text/css">
.mpLoader {
  position: relative;
  top: -44px;
  background: #968c8c;
    /* - */
  border: 6px solid #e3efee;
  border-radius: 50%;
  border-top: 6px solid red;
  width: 40px;
  height: 40px;
  -webkit-animation: spin 1s linear infinite;
  animation: spin 1s linear infinite;
}

/* Safari */
@-webkit-keyframes spin {
  0% { -webkit-transform: rotate(0deg); }
  100% { -webkit-transform: rotate(360deg); }
}

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}

.mploader_inactive{
  height: 12px;
}
</style>
EOF;
    echo $a;
}

/*                                      
 *                       MAIN CODE
 * 
 * ---------------------- warning -------------------------
 * If you change the default  ( $pP->cheForm = 'complex'; )
 * with                       ( $pP->cheForm = 'simple'; ) 
 * first deactivate the plugin or the relative db option
 * --------------------------------------------------------       
 * 
 */


$pP = new stdClass;
$pP->plugin_name = 'MinimumPlugin';
$pP->version = '1.0.0';
//  $pP->cheForm = 'simple';        /*  simple = form admin with one field               */
$pP->cheForm = 'complex';           /*  complex = form admin with more than one field    */
$pP->shortcode = 'MinimumPlugin';


register_activation_hook( __FILE__, 'activate_MinimumPlugin' );
register_deactivation_hook( __FILE__, 'deactivate_MinimumPlugin' );

/*  aggiungere il percorso del file .mo In questo plugin di test non ce ne sono */
add_action( 'plugins_loaded', 'textDomain_MinimumPlugin' ); //*

add_action('init', 'shortcodes_MinimumPlugin_init');

add_action( 'admin_init', 'register_setting_MinimumPlugin' );   //*

/*  add menu item. Submenu   */
add_action( 'admin_menu', 'add_options_page_MinimumPlugin' );   //*

/*      add only link settings  */
add_filter( 'plugin_action_links_'. plugin_basename(__FILE__), 'add_filter_link_MinimumPlugin' );   //*
    
   
if( false == get_option( $pP->plugin_name )){
    if( $pP->cheForm === 'simple' ){                        /*  single option  1 field */
        add_option($pP->plugin_name, '2020-12-25' );
    }
    elseif ( $pP->cheForm === 'complex' ) {                 /*  3 fields    */
        $ppIniVal = [ 'mpTxt' => 'Wedding Anniversary', 'mpData' => '2020-12-25', 'mpTime' => '00:00' ];
        add_option( $pP->plugin_name, ( array )$ppIniVal );
    }
    else { wp_die( __( 'database error' )); }
}

/* ******************** */
/*     AJAX  Test       */
/* ******************** */
/*  Administration page                              */
/*  mp_ajaxBK the action in javascript code          */
/*  mp_AjaxBKG the php function for manage ajax call */
add_action( 'wp_ajax_mp_ajaxBK', 'mp_AjaxBKG' );        /* only logged users */

/*  Frontend page                                       */
/*  mp_ajaxF  is the action in javascript code          */
/*  mp_AjaxFD is the php function for manage ajax call  */
add_action( 'wp_ajax_nopriv_mp_ajaxF', 'mp_AjaxFD');    /*  non logged users */

add_action('wp_ajax_mp_ajaxF', 'mp_AjaxFD');            /* also logged users */


/* ************** */
/*  Spin          */
/* ************** */
add_action( 'wp_head', 'mp_spinStyle', 5);